package testthreadid.handlers;

import org.eclipse.cdt.dsf.concurrent.DsfExecutor;
import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
import org.eclipse.cdt.dsf.debug.service.IProcesses;
import org.eclipse.cdt.dsf.debug.service.IProcesses.IThreadDMContext;
import org.eclipse.cdt.dsf.debug.service.IRunControl.IExecutionDMContext;
import org.eclipse.cdt.dsf.service.DsfServicesTracker;
import org.osgi.framework.BundleContext;


public class GetThreadIDRunnable implements Runnable {
	
	private IExecutionDMContext m_DMContext = null;
	private IThreadDMContext m_firstTriggeringThreadDMContext = null;
	private DsfExecutor m_executor = null;
	
	public GetThreadIDRunnable(final IExecutionDMContext DMContext,
								final IThreadDMContext firstTriggeringThreadDMContext,
								final DsfExecutor executor) {
		this.m_DMContext = DMContext;
		this.m_firstTriggeringThreadDMContext = firstTriggeringThreadDMContext;
		this.m_executor = executor;
	}
	
	@Override
	public void run() {		
		BundleContext bundleContext = TestThreadIDActivator.getDefault().getBundle().getBundleContext();
		DsfServicesTracker tracker = new DsfServicesTracker(bundleContext, this.m_DMContext.getSessionId());
		
		
		try {
			//Extract thread ID
			if (this.m_firstTriggeringThreadDMContext != null) {
				IProcesses processes = tracker.getService(IProcesses.class);
				final RequestMonitor requestMonitor = new RequestMonitor(this.m_executor, null);
				processes.getExecutionData(this.m_firstTriggeringThreadDMContext, new ThreadDMDataRequestMonitor(this.m_executor, requestMonitor));
			} else {
				System.out.println("No triggering thread");
			}
		} finally {
			tracker.dispose();
		}		

	}

}
